#!/usr/bin/env node

module.exports = extract


// requires
var commander = require('commander')
var debug     = require('debug')('extractors:www.pichunter.com')
var qpm_queue = require('qpm_queue')
var osmosis   = require('osmosis')
var solidbot  = require('../')
var uniq      = require('uniq')


// globals
var MAX_PAGES = 1000

var base      = 'http://www.xvideos.com'
var studio    = process.argv[2] || 'http://www.pichunter.com/sites/all/'+ 'Playboy' +'/'
var interval  = 2
var page      = 1
var nextPage  = 1
var uri       = studio + page
var turtle    = ''
var goAgain   = true
var count     = 1


var convertor = {
  'urn:string:video'  : ['a@href'],
  'http://xmlns.com/foaf/0.1/maker': ['.g_user@href'],
  'urn:string:depicts'             : ['.g_star'],
  'http://purl.org/dc/terms/title' : ['h1'],
  'urn:string:site'                : ['.g_site'],
  'urn:string:tag'                 : ['.tagCloud a'],
  'urn:string:next'                : ['.active ~'],
  'urn:string:imageGallery'        : ['.thumbtable .thumb@href']
}


function processGallery(uri) {
  if (uri.indexOf('#') === -1 ) {
    return uri
  }
  var arr = uri.split('/')
  arr.pop()
  return( arr.join('/') )
}


function getNextPage(ret) {
  var nextPage

  // process the data
  for (var k in ret) {
    if (ret.hasOwnProperty(k)) {
      v = ret[k]
      if (k === 'urn:string:next' ) {
        if (v && v[0]) {
          nextPage = parseInt(v[0])
        }
      }
    }
  }
  debug('nextpage', nextPage)
  return nextPage

}


function extract(studio) {

  return new Promise(function (res, rej) {
    qpm_queue.promiseWhile(function() {
      return goAgain
    }, function() {
      return new Promise(function(resolve, reject) {
        count++
        var uri = studio + nextPage
        debug(uri)
        solidbot.getPage(uri, convertor, interval)
        .then(function(ret) {

          debug('ret', ret)

          // process the data
          for (var k in ret) {
            if (ret.hasOwnProperty(k)) {
              v = ret[k]
              debug(k)
              debug(v)
              if (k === 'urn:string:next') {
                continue
              }
              if (k === 'urn:string:imageGallery') {
                for (var i = 0; i < v.length; i++) {
                  v[i] = processGallery(v[i])
                }
              }
              debug('end')
              turtle += solidbot.toTurtle(k, v, base)
            }
          }

          // paginate
          nextPage = getNextPage(ret)
          debug('page', page)
          debug('nextPage', nextPage)
          if (nextPage && !isNaN(parseInt(nextPage)) && nextPage === (page + 1)  && count < MAX_PAGES ) {
            debug('goAgain')
            page = nextPage
            goAgain = true
            uri = studio + nextPage
            resolve()
          } else {
            goAgain = false
            resolve()
          }

        })
      })
    }).then(function() {
      // finally
      var unique = solidbot.sortUnique(turtle)
      res(unique)
    })

  })


}


function bin(argv) {
  studio = argv[2] || 'http://www.pichunter.com/sites/all/'+ 'Playboy' +'/'

  var turtle = extract(studio).then(function (turtle) {
    console.log(turtle)
  })
}


// If one import this file, this is a module, otherwise a library
if (require.main === module) {
  bin(process.argv);
}
